/* server.cmdline.h */

/* File autogenerated by gengetopt version 2.14  */

#ifndef SERVER_CMDLINE_H
#define SERVER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "para_server"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "(paraslash 0.2.5, aggressive resolution)\nCopyright (c) 1997-2005 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct gengetopt_args_info
{
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/* set loglevel (0-6) original value given at command line.  */
  int port_arg;	/* port to listen on (default='2990').  */
  char * port_orig;	/* port to listen on original value given at command line.  */
  int daemon_flag;	/* run as background daemon (default=off).  */
  char * user_arg;	/* run as user 'username'. para_server does not need any special privileges. If started as root (EUID == 0) this option must be given at the command line (not in the configuration file) so that para_server can drop the root privileges right after parsing the command line options, but before parsing the configuration file. In this case, real/effective/saved UID are all set to the UID of 'username'. As the configuration file is read afterwards, those options that have a default value depending on the UID (e.g. the home directory for the configuration file) are computed by using the uid of 'username'. This option has no effect if para_server ist started as a non-root user (i.e.  EUID != 0).  */
  char * user_orig;	/* run as user 'username'. para_server does not need any special privileges. If started as root (EUID == 0) this option must be given at the command line (not in the configuration file) so that para_server can drop the root privileges right after parsing the command line options, but before parsing the configuration file. In this case, real/effective/saved UID are all set to the UID of 'username'. As the configuration file is read afterwards, those options that have a default value depending on the UID (e.g. the home directory for the configuration file) are computed by using the uid of 'username'. This option has no effect if para_server ist started as a non-root user (i.e.  EUID != 0) original value given at command line.  */
  char * logfile_arg;	/* (default=stdout/stderr).  */
  char * logfile_orig;	/* (default=stdout/stderr) original value given at command line.  */
  char * config_file_arg;	/* (default='~/.paraslash/server.conf'.  */
  char * config_file_orig;	/* (default='~/.paraslash/server.conf' original value given at command line.  */
  char * user_list_arg;	/* (default='~/.paraslash/server.users').  */
  char * user_list_orig;	/* (default='~/.paraslash/server.users') original value given at command line.  */
  int autoplay_flag;	/* start playing on startup (default=off).  */
  int announce_time_arg;	/* Delay betweeen announcing the stream and sending data (default='300').  */
  char * announce_time_orig;	/* Delay betweeen announcing the stream and sending data original value given at command line.  */
  char * dbtool_arg;	/* (default=first available that works).  */
  char * dbtool_orig;	/* (default=first available that works) original value given at command line.  */
  char * mysql_host_arg;	/* mysql server (default='localhost').  */
  char * mysql_host_orig;	/* mysql server original value given at command line.  */
  int mysql_port_arg;	/* where mysql is listening (default='3306').  */
  char * mysql_port_orig;	/* where mysql is listening original value given at command line.  */
  char * mysql_user_arg;	/* default value: username from /etc/passwd.  */
  char * mysql_user_orig;	/* default value: username from /etc/passwd original value given at command line.  */
  char * mysql_passwd_arg;	/* (required).  */
  char * mysql_passwd_orig;	/* (required) original value given at command line.  */
  char * mysql_database_arg;	/* name of mysql database (default='paraslash').  */
  char * mysql_database_orig;	/* name of mysql database original value given at command line.  */
  char * mysql_find_cmd_arg;	/* cmd to locate sound files (required).  */
  char * mysql_find_cmd_orig;	/* cmd to locate sound files (required) original value given at command line.  */
  char * mysql_default_score_arg;	/* scoring rule to use if stream definition does not contain explicit score definition (default='(LASTPLAYED() / 1440 - 1000 / (LASTPLAYED() + 1) - sqrt(NUMPLAYED()))').  */
  char * mysql_default_score_orig;	/* scoring rule to use if stream definition does not contain explicit score definition original value given at command line.  */
  char * dopey_dir_arg;	/* dir to search for files to be streamed (default='/home/music').  */
  char * dopey_dir_orig;	/* dir to search for files to be streamed original value given at command line.  */
  int http_port_arg;	/* tcp port for http streaming (default='8000').  */
  char * http_port_orig;	/* tcp port for http streaming original value given at command line.  */
  int http_default_deny_flag;	/* deny connections from hosts which are not explicitly allowed (default=off).  */
  char ** http_access_arg;	/* Add given host/network to access control list (whitelist if http_default_deny was given, blacklist otherwise) before opening the tcp port. This option can be given multiple times. Example: '192.168.0.0/24' whitelists/blacklists the 256 hosts 192.168.0.x.  */
  char ** http_access_orig;	/* Add given host/network to access control list (whitelist if http_default_deny was given, blacklist otherwise) before opening the tcp port. This option can be given multiple times. Example: '192.168.0.0/24' whitelists/blacklists the 256 hosts 192.168.0.x original value given at command line.  */
  int http_no_autostart_flag;	/* do not open tcp port on server startup (default=off).  */
  int http_max_clients_arg;	/* maximal simultaneous connections, non-positive value means unlimited (default='-1').  */
  char * http_max_clients_orig;	/* maximal simultaneous connections, non-positive value means unlimited original value given at command line.  */
  char ** ortp_target_arg;	/* Add given host/port to the list of targets. This option can be given multiple times. Example: '224.0.1.38:1500' instructs the ortp sender to send to udp port 1500 on host 224.0.1.38 (unassigned ip in the Local Network Control Block 224.0.0/24). This is useful for LAN-streaming..  */
  char ** ortp_target_orig;	/* Add given host/port to the list of targets. This option can be given multiple times. Example: '224.0.1.38:1500' instructs the ortp sender to send to udp port 1500 on host 224.0.1.38 (unassigned ip in the Local Network Control Block 224.0.0/24). This is useful for LAN-streaming. original value given at command line.  */
  int ortp_no_autostart_flag;	/* do not start to send automatically (default=off).  */
  int ortp_default_port_arg;	/* default udp port if not specified (default='1500').  */
  char * ortp_default_port_orig;	/* default udp port if not specified original value given at command line.  */
  int ortp_header_interval_arg;	/* time between extra header sends (default='2000').  */
  char * ortp_header_interval_orig;	/* time between extra header sends original value given at command line.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int port_given ;	/* Whether port was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int user_given ;	/* Whether user was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int config_file_given ;	/* Whether config_file was given.  */
  int user_list_given ;	/* Whether user_list was given.  */
  int autoplay_given ;	/* Whether autoplay was given.  */
  int announce_time_given ;	/* Whether announce_time was given.  */
  int dbtool_given ;	/* Whether dbtool was given.  */
  int mysql_host_given ;	/* Whether mysql_host was given.  */
  int mysql_port_given ;	/* Whether mysql_port was given.  */
  int mysql_user_given ;	/* Whether mysql_user was given.  */
  int mysql_passwd_given ;	/* Whether mysql_passwd was given.  */
  int mysql_database_given ;	/* Whether mysql_database was given.  */
  int mysql_find_cmd_given ;	/* Whether mysql_find_cmd was given.  */
  int mysql_default_score_given ;	/* Whether mysql_default_score was given.  */
  int dopey_dir_given ;	/* Whether dopey_dir was given.  */
  int http_port_given ;	/* Whether http_port was given.  */
  int http_default_deny_given ;	/* Whether http_default_deny was given.  */
  unsigned int http_access_given ;	/* Whether http_access was given.  */
  int http_no_autostart_given ;	/* Whether http_no_autostart was given.  */
  int http_max_clients_given ;	/* Whether http_max_clients was given.  */
  unsigned int ortp_target_given ;	/* Whether ortp_target was given.  */
  int ortp_no_autostart_given ;	/* Whether ortp_no_autostart was given.  */
  int ortp_default_port_given ;	/* Whether ortp_default_port was given.  */
  int ortp_header_interval_given ;	/* Whether ortp_header_interval was given.  */

} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SERVER_CMDLINE_H */
